# -*- coding: utf-8 -*-
from setuphelpers import *
from setupdevhelpers import *
import glob

def update_package():
    # Declaring local variables
    package_updated = False
    
    proxies = get_proxies_from_wapt_console()
    if not proxies:
        proxies = get_proxies()

    url_base = "https://www.arcserve.com/software-downloads/shadowprotect"
    response = requests.get(url_base, allow_redirects=True, proxies=proxies)
    
    # Extract the correct div using bs_find_all
    divs = bs_find_all(response.text, "div", "class", "software-downloads-cta", proxies=proxies)
    exe_file = None
    
    # Debugging to check if divs were found
    if not divs:
        print("No div found with the class 'software-downloads-cta'.")
        return
    
    print(f"Number of divs found with 'software-downloads-cta': {len(divs)}")
    
    # Loop through the divs to find the one containing the .exe link for ImageManager
    for div in divs:
        links = div.find_all('a', href=True)
        for link in links:
            # Check if the link contains 'ImageManager_Setup' and ends with .exe
            if "ImageManager_Setup" in link['href'] and link['href'].endswith('.exe'):
                exe_file = link['href']
                if exe_file.startswith("/"):
                    exe_file = "https://downloads.storagecraft.com" + exe_file  # Case when the link is relative
                latest_bin = exe_file.split('/')[-1]
                download_url = exe_file
                version = latest_bin.split('-')[-1].rsplit('.exe')[0]
                break

    # Downloading latest binaries
    print("Download URL is: %s" % download_url)
    if not isfile(latest_bin):
        print("Downloading: %s" % latest_bin)
        wget(download_url, latest_bin, proxies=proxies)
        package_updated = True
    else:
        print("Binary is present: %s" % latest_bin)

    # Deleting outdated binaries
    for f in glob.glob('*.zip'):
        if f != latest_bin:
            remove_file(f)

    # Get version from binary
    version = get_version_from_binary(latest_bin)
    
    # Update the package
    control.set_software_version(version)
    control.save_control_to_wapt()    
